/*****************************************************************************
**               AMICCOM Electronics Corporation Document                   **
**          Copyright (c) 2011-2014 AMICCOM Electronics Corporation         **
**                                                                          **
**      A3,1F,No.1, Li-Hsin 1th Road, Science_Based Industrid Park,         **
**                       Hsin_Chu City, 300, Taiwan, ROC.                   **
**                 Tel: 886-3-5785818   Fax: 886-3-5785819                  **
**         E-mail:info@amiccom.com.tw  http: //www.amiccom.com.tw           **
*****************************************************************************/
#ifndef _function_h_
#define _function_h_
#include "define.h"

/*********************************************************************
**  function Declaration
*********************************************************************/

// function
extern void     InitMCU(void);
extern void     Err_State(void);
extern Uint8    A9139M0_WriteID(void);
extern void     TXPower( Uint32 TBG, Uint32 TDC, Uint32 PAC);//, Uint8 ConfigType );
extern void     FIFOLength ( Uint16 FEP );
extern void     TXModeSel ( Uint8 MODE);//, Uint8 ConfigType );
extern void     TXModulation ( Uint8 MODE);//, Uint8 ConfigType );
extern void     SetCRC ( Uint8 crcs,Uint8 crc16,Uint8 crcmode  ,Uint8 ConfigType );
extern void     PM1(void);

// interrupt
extern void     Uart0_interrupt(void);
extern void     Timer0_Interrupt(void);
extern void     Timer1_Interrupt(void);
extern void     DualTimer1_Interrupt(void);
extern void     SleepTimer0_Interrupt(void);
extern void     SleepTimer1_Interrupt(void);

// Library
extern void     MasterNodeSet(Uint8 Num1);
extern void     InitDualTimer1(void);
extern void     EnableDualTimer1(void);
extern void     DisableDualTimer1(void);
extern void     InitTimer1(void);
extern void     InitTimer0(void);
extern void     EnableTimer0(void);
extern void     Init_TMR ( Uint8 ConfigType );
extern void     InitNodeBuffer(void);
extern void     InitMaster(void);
extern void     InitSlave(void);
extern void     RF_IOSettingx(void);
extern void     SetMasterTx_RSSI_Threshold(Uint8 Level);
extern void     SetMasterDataLostBackLinkMode(Uint8 Time);
extern void     SetSlaveDataLostBackLinkMode(Uint8 Time);
extern void     SetSlaveLinkTimeout(Uint16 Time);
extern void     SetSlaveReLinkTime(Uint8 Time);
extern void     SetSlaveReLinkSleepTimer(Uint8 Time);
extern void     MasterProcess(void);
extern void     SlavePowerDown(void);
extern void     SlaveProcessFristStart(void);
extern void     SlaveProcess(void);


// Main
//extern void     uartTx(Uint8 length);

#endif
