/*****************************************************************************
**               AMICCOM Electronics Corporation Document                   **
**          Copyright (c) 2011-2014 AMICCOM Electronics Corporation         **
**                                                                          **
**      A3,1F,No.1, Li-Hsin 1th Road, Science_Based Industrid Park,         **
**                       Hsin_Chu City, 300, Taiwan, ROC.                   **
**                 Tel: 886-3-5785818   Fax: 886-3-5785819                  **
**         E-mail:info@amiccom.com.tw  http: //www.amiccom.com.tw           **
*****************************************************************************/

#include "..\include\main.h"
#include "..\include\function.h"
#include "..\include\ExternVar.h"

/*********************************************************************
** InitMCU
*********************************************************************/
void InitMCU( void )
{		
//		GPIO0->OUTENABLESET = 0xFFFFFEFF;	//P0.8 	
//		GPIO0->PUN = 0xFFFFFFFF;
//		GPIO0->WUN = 0xFFFFFFFF;		

    NVIC->ICER[0] = 0xFFFFFFFF;    //Interrupt Clear Enable

    GPIO0->DATA = 0xFFFFFFFF;
    GPIO0->OUTENABLESET = 0x0000000F;
//    GPIO0->ALTFUNCSET = 0x00C0E000;
    GPIO0->ALTFUNCSET = 0x00000000;
    GPIO0->PUN = 0x0000000F;
    GPIO0->WUN = 0xFFFFFFFF;
}


/************************************************************************
**  Err_State
************************************************************************/
void Err_State ( void )
{
    //ERR display
    //Error Proc...
    //...
	
		/* Watchdog reset */
		//WDTReset();	
                     

    while ( 1 );
}

/************************************************************************
**  PM1
************************************************************************/
void PM1 ( void )
{    
    OUTEN_Reg = GPIO0->OUTENABLESET;  
    PUN_Reg = GPIO0->PUN;    
    WUN_Reg = GPIO0->WUN;
    ALTFUNSET_Reg = GPIO0->ALTFUNCSET;

    //all pin as input and pull high
    GPIO0->OUTENABLECLR = 0xFFFFFFFF;  
    GPIO0->PUN = 0x00000000;  
    GPIO0->WUN = 0xFFFFFFFF;    
    
    POWER->PWR_TA = 0xAAAAAAAA;
    POWER->PWR_TA = 0x55555555;    
    POWER->IO_CTRL0 = 0x00000000;  
    POWER->PWR_TA = 0xAAAAAAAA;
    POWER->PWR_TA = 0x55555555;    
    POWER->IO_CTRL1 = 0x00000000;  
    POWER->PWR_TA = 0xAAAAAAAA;
    POWER->PWR_TA = 0x55555555;    
    POWER->IO_CTRL2 = 0x00000000;  
    POWER->PWR_TA = 0xAAAAAAAA;
    POWER->PWR_TA = 0x55555555;    
    POWER->IO_CTRL3 = 0x00000000;  
  
    PWRCTL2_Reg = ( ( PWRCTL2_Reg & ~0x0000008F ) | 0x0000008A );    
    POWER->PWR_TA = 0xAAAAAAAA;
    POWER->PWR_TA = 0x55555555;    
    POWER->POWERCTRL2 = PWRCTL2_Reg; //b0:QDSD=0, b1:ENDV=1, b2:QDSA=0, b3:ENAV=1, b7:ENPV=1

    __nop();
    __nop();
    __nop();
    __nop();    
            
     POWER->POWERCTRL3 = 0x01141000; //b18:QDS_CACHE 0R=1, b20:QDS_CACHE 1R=1        
    //SRAM1K Always Exist(0x20000000 ~ 0x200003FF)
    //If you want add SRAM memory keeps, you can use setting as below:
    //FPCTL_Reg = 0x00000595; // SRAM 15K OFF
    FPCTL_Reg = 0x000005A5; // SRAM 15K ON (0x20000400 ~ 0x20003FFF)
    POWER->PWR_TA = 0xAAAAAAAA;
    POWER->PWR_TA = 0x55555555;
    POWER->FALSHCTRL = FPCTL_Reg;  
    RFLIB_StrobeCmd ( CMD_SLEEP );
    POWER->PowerManagement = 0x00000002; //b1:Stop=1

    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
    __nop();
          
    PWRCTL2_Reg = A9139M0_Config[INDEX_PWRCTL2].load[ConfigType];   
    POWER->PWR_TA = 0xAAAAAAAA;
    POWER->PWR_TA = 0x55555555;    
    POWER->POWERCTRL2 = PWRCTL2_Reg; 
    
    GPIO0->OUTENABLESET = OUTEN_Reg;  
    GPIO0->PUN = PUN_Reg;  
    GPIO0->WUN = WUN_Reg;
    GPIO0->ALTFUNCSET = ALTFUNSET_Reg;
}

/************************************************************************
**  A9139_WriteID
************************************************************************/
Uint8 A9139M0_WriteID ( void )
{
    Uint32 tmp1,tmp2;

    //Write ID
    tmp1 = ID_Tab[0]<<24 | ID_Tab[1]<<16 | ID_Tab[2]<<8 | ID_Tab[3];
    RFLIB_WriteID(tmp1);   
   
    //Read ID   
    tmp2 = RFLIB_ReadID();  
   
    //check ID
    if ( tmp1 != tmp2 )
        return FAIL;

    return PASS;
}

//20220916/************************************************************************
//20220916**  TXPower
//20220916**
//20220916**  TBG Range 0~63
//20220916**  TDC Range 0~3
//20220916**  PAC Range 0~3
//20220916************************************************************************/
//20220916void TXPower ( Uint8 TBG, Uint8 TDC, Uint8 PAC, Uint8 ConfigType )
//20220916{
//20220916    RFLIB_WriteReg ( TX1_REG, ( ( ( A9139Config[ConfigType][TX1_REG - CONFIG] ) & ~0x60 ) | ( ( TDC & 0x03 ) << 5 ) ) );
//20220916    RFLIB_WriteReg ( TX4_REG, ( ( ( A9139Config[ConfigType][TX4_REG - CONFIG] ) & ~0xFF ) | ( ( TBG & 0x3F ) << 0 ) | ( ( PAC & 0x03 ) << 6 ) ) );
//20220916}
//20220916
/************************************************************************
**  FIFOLength
**
**  FEP Range 0~16384
************************************************************************/
void FIFOLength ( Uint16 FEP )
{
		RADIO->FIFOCTRL = FEP;		
//20220916    RFLIB_WriteReg ( FIFO1_REG, ( ( FEP - 1 ) & 0xFF ) );
//20220916    RFLIB_WriteReg ( VCB1_REG,  ( ( ( A9139Config[ConfigType][VCB1_REG - CONFIG] ) & ~0x3F ) | ( ( ( FEP - 1 ) & 0x3F00 ) >> 8 ) ) );
}

/************************************************************************
**  TXPower
************************************************************************/
void TXPower ( Uint32 tbg, Uint32 tdc, Uint32 pac )
{
    TXPWR_Reg = ( ( TXPWR_Reg & ~0x000003FF ) | ( tbg & 0x3F ) | ( ( tdc & 0x03 ) << 8 ) | ( ( pac & 0x03 ) << 6 ) );
    RADIO->TXPOWER = TXPWR_Reg;
}

/************************************************************************
**  TXModeSel
**
**  MODE : 0 - DIRECT MODE ; 1 - FIFO MODE
************************************************************************/
void TXModeSel ( Uint8 mode )
{
    if ( mode == DIRECT )
    {
        MODEC2_Reg = MODEC2_Reg & ~0x00000002; //b1:FMS=0
    }
    else
    {
        MODEC2_Reg = ( ( MODEC2_Reg & ~0x00000002 ) | BIT1 ); //b1:FMS=1
    }
    
    RADIO->MODECTRL2 = MODEC2_Reg;    
}

/************************************************************************
**  TXModulation
************************************************************************/
void TXModulation ( Uint8 mode )
{
    if ( mode == ENABLE )
    {
         TXCTL_Reg = ( ( TXCTL_Reg & ~0x00000002 ) | BIT1 ); //TME = 1
    }
    else
    {
        TXCTL_Reg = ( TXCTL_Reg & ~0x00000002 ); //TME = 0
    }
    
    RADIO->TXCTL = TXCTL_Reg;    
}

//20220916/*****************************************************************************
//20220916**  Function    : SetCRC                                                    **
//20220916*****************************************************************************/
//20220916void SetCRC ( Uint8 crcs,Uint8 crc16,Uint8 crcmode  ,Uint8 ConfigType )
//20220916{
//20220916    RFLIB_WriteReg ( CODE2_REG, ( ( ( A9139Config[ConfigType][CODE2_REG - CONFIG] ) & ~0x20 ) | ( ( crcs & 0x01 ) << 5 ) ) );
//20220916    
//20220916    //RFLIB_WriteReg ( SYN1_REG, ( ( ( A9139Config[ConfigType][SYN1_REG - CONFIG] ) & ~0x38 ) |  (   (crc16 & 0x01)  << 5  ) |  (   (crcmode & 0x03)  << 3  ) ));
//20220916    RFLIB_WriteReg ( SYN1_REG, ( ( ( 0x01 ) & ~0x38 ) |  (   (crc16 & 0x01)  << 5  ) |  (   (crcmode & 0x03)  << 3  ) ));
//20220916}
//20220916

